Index: /trunk/src/objects/RpPool.h
===================================================================
--- /trunk/src/objects/RpPool.h	(revision 1270)
+++ /trunk/src/objects/RpPool.h	(revision 1270)
@@ -0,0 +1,36 @@
+#ifndef RP_POOL_H
+#define RP_POOL_H
+
+typedef struct Rp_PoolChainStruct {
+   struct Rp_PoolChainStruct *nextPtr;
+} Rp_PoolChain;
+
+#define RP_STRING_ITEMS         0
+#define RP_FIXED_SIZE_ITEMS     1
+#define RP_VARIABLE_SIZE_ITEMS  2
+
+typedef struct Rp_PoolStruct *Rp_Pool;
+
+typedef void *(Rp_PoolAllocProc) _ANSI_ARGS_((Rp_Pool pool, size_t size));
+typedef void (Rp_PoolFreeProc) _ANSI_ARGS_((Rp_Pool pool, void *item));
+
+struct Rp_PoolStruct {
+    Rp_PoolChain *headPtr;  /* Chain of malloc'ed chunks. */
+    Rp_PoolChain *freePtr;  /* List of deleted items. This is only used
+                             * for fixed size items. */
+    size_t poolSize;        /* Log2 of # of items in the current block. */
+    size_t itemSize;        /* Size of an item. */
+    size_t bytesLeft;       /* # of bytes left in the current chunk. */
+    size_t waste;
+
+    Rp_PoolAllocProc *allocProc;
+    Rp_PoolFreeProc *freeProc;
+};
+
+extern Rp_Pool Rp_PoolCreate _ANSI_ARGS_((int type));
+extern void Rp_PoolDestroy _ANSI_ARGS_((Rp_Pool pool));
+
+#define Rp_PoolAllocItem(poolPtr, n) (*((poolPtr)->allocProc))(poolPtr, n)
+#define Rp_PoolFreeItem(poolPtr, item) (*((poolPtr)->freeProc))(poolPtr, item)
+
+#endif /* RP_POOL_H */
Index: /trunk/src/objects/RpUtils2.c
===================================================================
--- /trunk/src/objects/RpUtils2.c	(revision 1270)
+++ /trunk/src/objects/RpUtils2.c	(revision 1270)
@@ -0,0 +1,28 @@
+#include <stdio.h>
+#include <stdarg.h>
+
+void
+Rp_Assert(testExpr, fileName, lineNumber)
+    char *testExpr;
+    char *fileName;
+    int lineNumber;
+{
+    fprintf(stderr, "line %d of %s: Assert \"%s\" failed\n",
+    lineNumber, fileName, testExpr);
+    fflush(stderr);
+    abort();
+}
+
+void
+Rp_Panic (
+    const char *format,
+    ...)
+{
+    va_list argList;
+
+    va_start(argList, format);
+    vfprintf(stderr, format, argList);
+    fprintf(stderr, "\n");
+    fflush(stderr);
+    abort();
+}
Index: /trunk/src/objects/RpVariable.cc
===================================================================
--- /trunk/src/objects/RpVariable.cc	(revision 1269)
+++ /trunk/src/objects/RpVariable.cc	(revision 1270)
@@ -7,5 +7,5 @@
  * ======================================================================
  *  AUTHOR:  Derrick Kearney, Purdue University
- *  Copyright (c) 2004-2005  Purdue Research Foundation
+ *  Copyright (c) 2005-2009  Purdue Research Foundation
  *
  *  See the file "license.terms" for information on usage and
@@ -14,207 +14,115 @@
  */
 
- #include "RpVariable.h"
+#include <cstring>
+#include <stdlib.h>
+#include "RpVariable.h"
+#include "RpHashHelper.h"
 
-/**********************************************************************/
-// METHOD: setPath()
-/// Set the path of this object
-/**
- */
-
-RpVariable&
-RpVariable::setPath(std::string newPath)
+RpVariable::RpVariable()
 {
-    path = newPath;
-    return *this; 
+    __init();
 }
 
-/**********************************************************************/
-// METHOD: setDefaultValue()
-/// Set the default value of this object
-/**
- */
-
-RpVariable&
-RpVariable::setDefaultValue(void* newDefaultVal)
+RpVariable::RpVariable(const RpVariable& o)
+    :
+        _path (o._path)
 {
-    // who is responsible for freeing the pointer?
-    defaultVal = newDefaultVal; 
-    return *this; 
+    if (o._h != NULL) {
+        Rp_HashCopy(_h,o._h,charCpyFxn);
+    }
 }
 
-/**********************************************************************/
-// METHOD: setCurrentValue()
-/// Set the current value of this object
-/**
- */
-
-RpVariable&
-RpVariable::setCurrentValue(void* newCurrentVal)
+RpVariable::~RpVariable()
 {
-    // who is responsible for freeing the pointer?
-    currentVal = newCurrentVal; 
-    return *this; 
+    __close();
 }
 
-/**********************************************************************/
-// METHOD: setLabel()
-/// Set the label of this object
-/**
- */
-
-RpVariable&
-RpVariable::setLabel(std::string newLabel)
+const char *
+RpVariable::label(
+    const char *val)
 {
-    about.setLabel(newLabel); 
-    return *this; 
+    return (const char *) property("label",val);
 }
 
-/**********************************************************************/
-// METHOD: setDesc()
-/// Set the desc of this object
-/**
- */
-
-RpVariable& 
-RpVariable::setDesc(std::string newDesc)
+const char *
+RpVariable::desc(
+    const char *val)
 {
-    about.setDesc(newDesc); 
-    return *this; 
+    return (const char *) property("desc",val);
 }
 
-/**********************************************************************/
-// METHOD: setHints()
-/// Set the hints of this object
-/**
- */
-
-RpVariable& 
-RpVariable::setHints(std::string newHints)
+const char *
+RpVariable::hints(
+    const char *val)
 {
-    about.setHints(newHints); 
-    return *this; 
+    return (const char *) property("hints",val);
 }
 
-/**********************************************************************/
-// METHOD: setColor()
-/// Set the color of this object
-/**
- */
-
-RpVariable& 
-RpVariable::setColor(std::string newColor)
+const char *
+RpVariable::color(
+    const char *val)
 {
-    about.setColor(newColor); 
-    return *this; 
+    return (const char *) property("color",val);
 }
 
-/**********************************************************************/
-// METHOD: setIcon()
-/// Set the icon of this object 
-/**
- */
-
-RpVariable& 
-RpVariable::setIcon(std::string newIcon)
+const char *
+RpVariable::icon(
+    const char *val)
 {
-    about.setIcon(newIcon); 
-    return *this; 
+    return (const char *) property("icon",val);
 }
 
-
-/**********************************************************************/
-// METHOD: getPath()
-/// Report the path of this object
-/**
- */
-
-std::string 
-RpVariable::getPath() const
+const char *
+RpVariable::path(
+    const char *val)
 {
-    return path; 
+    return (const char *) property("path",val);
 }
 
-/**********************************************************************/
-// METHOD: getDefaultValue()
-/// Report the default value of the object
-/**
- */
+const void *
+RpVariable::property(
+    const char *key,
+    const void *val)
+{
+    const void *r = NULL;
+    if (_h == NULL) {
+        // hash table does not exist, create it
+        _h = (Rp_HashTable*) malloc(sizeof(Rp_HashTable));
+        Rp_InitHashTable(_h,RP_STRING_KEYS);
+        return NULL;
+    }
 
-void*
-RpVariable::getDefaultValue() const
-{
-    return defaultVal; 
+    if (val == NULL) {
+        // get the value
+        r = Rp_HashSearchNode(_h,key);
+    } else {
+        //set the value
+        Rp_HashRemoveNode(_h,key);
+        Rp_HashAddNode(_h,key,val);
+        r = val;
+    }
+
+    return r;
 }
 
-/**********************************************************************/
-// METHOD: getCurrentValue()
-/// Report the current value of the object
-/**
- */
-
-void* 
-RpVariable::getCurrentValue() const
+void
+RpVariable::__init()
 {
-    return currentVal; 
+    _path = NULL;
+    _h = NULL;
 }
 
-/**********************************************************************/
-// METHOD: getLabel()
-/// Report the label of the object
-/**
- */
+void
+RpVariable::__close()
+{
+    if (_path != NULL) {
+        free((void *)_path);
+    }
 
-std::string 
-RpVariable::getLabel() const
-{
-    return about.getLabel(); 
-}
+    if (_h != NULL) {
+        Rp_DeleteHashTable(_h);
+    }
 
-/**********************************************************************/
-// METHOD: getDesc()
-/// Report the desc of the object
-/**
- */
-
-std::string 
-RpVariable::getDesc() const
-{
-    return about.getDesc(); 
-}
-
-/**********************************************************************/
-// METHOD: getHints()
-/// Report the hints of this object
-/**
- */
-
-std::string 
-RpVariable::getHints() const
-{
-    return about.getHints(); 
-}
-
-/**********************************************************************/
-// METHOD: getColor()
-/// Report the color of this object
-/**
- */
-
-std::string 
-RpVariable::getColor() const
-{
-    return about.getColor(); 
-}
-
-/**********************************************************************/
-// METHOD: getIcon()
-/// Report the icon of this object
-/**
- */
-
-std::string 
-RpVariable::getIcon() const
-{
-    return about.getIcon(); 
+    __init();
 }
 
Index: /trunk/src/objects/RpVariable.h
===================================================================
--- /trunk/src/objects/RpVariable.h	(revision 1269)
+++ /trunk/src/objects/RpVariable.h	(revision 1270)
@@ -1,5 +1,6 @@
 /*
  * ======================================================================
- *  Copyright (c) 2004-2005  Purdue Research Foundation
+ *  AUTHOR:  Derrick S. Kearney, Purdue University
+ *  Copyright (c) 2005-2009  Purdue Research Foundation
  *
  *  See the file "license.terms" for information on usage and
@@ -7,99 +8,39 @@
  * ======================================================================
  */
-#include <iostream>
-#include <string>
-#include <sstream>
-#include <stdlib.h>
-#include <errno.h>
 
+#ifndef _RpVARIABLE_H
+#define _RpVARIABLE_H
 
-// #include "RpLibrary.h"
-
-#ifndef _RpABOUT_H
-    #include "RpAbout.h"
-#endif
-
-#ifndef _RpVARIABLE_H 
-#define _RpVARIABLE_H
+#include "RpInt.h"
+#include "RpHash.h"
 
 class RpVariable
 {
     public:
-        
-        // users member fxns
+        RpVariable ();
+        RpVariable (const RpVariable& o);
+        virtual ~RpVariable();
 
-        virtual RpVariable& setPath         (std::string newPath);
-        virtual RpVariable& setDefaultValue (void* newDefaultVal);
-        virtual RpVariable& setCurrentValue (void* newCurrentVal);
-        virtual RpVariable& setLabel        (std::string newLabel);
-        virtual RpVariable& setDesc         (std::string newDesc);
-        virtual RpVariable& setHints        (std::string newHints);
-        virtual RpVariable& setColor        (std::string newColor);
-        virtual RpVariable& setIcon         (std::string newIcon);
-
-        virtual std::string getPath         () const;
-        /* maybe we dont need 2 get functions? */
-        virtual void* getDefaultValue       () const;
-        virtual void* getCurrentValue       () const;
-        virtual std::string getLabel        () const;
-        virtual std::string getDesc         () const;
-        virtual std::string getHints        () const;
-        virtual std::string getColor        () const;
-        virtual std::string getIcon         () const;
-
-        // place the information from this object into the xml library 'lib'
-        // virtual RpNumber& put(RpLibrary lib);
-        // virtual RpVariable& put() const;
-
-        // we need a copy of defaultVal in currentVal, not the same pointer.
-        // need to fix this.
-        
-        RpVariable (
-                    std::string path, 
-                    void* defaultVal
-                )
-            :   about       (RpAbout()),
-                path        (path),
-                defaultVal  (defaultVal),
-                currentVal  (defaultVal)
-        {
-            // about's default no-arg const is called
-        };
-
-        RpVariable (
-                    std::string path, 
-                    void* defaultVal,
-                    std::string label,
-                    std::string desc
-                )
-            :   about       (RpAbout(label,desc)),
-                path        (path),
-                defaultVal  (defaultVal),
-                currentVal  (defaultVal)
-        {}
-        
-        // copy constructor
-        RpVariable ( const RpVariable& myRpVariable ) 
-                // will the RpAbout copy constructor be called here?
-            :   about       (RpAbout(myRpVariable.about)),
-                path        (myRpVariable.path),
-                defaultVal  (myRpVariable.defaultVal),
-                currentVal  (myRpVariable.currentVal)
-        {}
-
-        // default destructor
-        virtual ~RpVariable ()
-        {
-            // clean up dynamic memory
-        }
+        virtual const char *label           (const char *val);
+        virtual const char *desc            (const char *val);
+        virtual const char *hints           (const char *val);
+        virtual const char *color           (const char *val);
+        virtual const char *icon            (const char *val);
+        virtual const char *path            (const char *val);
+        virtual const void *property        (const char *key, const void *val);
 
     private:
 
-        RpAbout about;
-        std::string path;
-        void* defaultVal;
-        void* currentVal;
+        /// path of the object in the xml tree and key in hash tables
+        const char *_path;
 
+        /// hash table holding other object properties
+        Rp_HashTable *_h;
 
+        /// initialize the object, set the data members to 0 or null
+        void __init();
+
+        /// close out the object, freeing its memory
+        void __close();
 };
 
